<?php
require_once(dirname(dirname(dirname(dirname(__FILE__)))) .'/service/requestRemote.php');
class Topcmmchat_Component_Controller_Admincp_Settings extends Phpfox_Component{
    public function process(){
		if($this->request()->get('extendserver') != ''){
        	$this->saveFcConfig();        	
        }
        $aSettings = Phpfox::getService('topcmmchat') -> getFcSettings();
        $login_chat = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'].'?do=/topcmmchat/loginchat&username=%username%&password=%password%';
        $this->template()->setTitle(Phpfox::getPhrase('topcmmchat.settings'))
        	->setBreadcrumb(Phpfox::getPhrase('topcmmchat.settings'))
			->setPhrase(array('topcmmchat.settings'))
			->assign(array(
                'settings' => $aSettings,
                'login_chat' => $login_chat,
				'server_name'	=> $_SERVER['SERVER_NAME'],
                'valid' => Phpfox::getService('topcmmchat') -> getValid($aSettings)
        	)
        );
    }
    
	private function saveFcConfig(){
    	switch ($this->request()->get('extendserver')){
			case 0:
    			$aSettings = $this->setFcOwnSetting();
				$aSettings['fc_extendserver'] = 0;
				$c_own_loc = 1;
				$da = 1;
				
				if($this->request()->get('server_loc')){
					$c_own_loc = Phpfox::getService('topcmmchat') -> validate_client($aSettings['fc_client_loc']);
					$da = Phpfox::getService('topcmmchat') -> validate_data_api($aSettings['fc_api_url'] . 'online.js');
					if($c_own_loc || $da){
						//$showmessenge = 'Chat Server host or port is configured incorrectly';
						$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Chat Server host or port is configured incorrectly!</span>');
					}
				}else{
					$c_own_loc = Phpfox::getService('topcmmchat') -> validate_client($aSettings['fc_client_loc']);
					if($c_own_loc){
						//$showmessenge = 'Chat Server host or http_port is configured incorrectly';
						$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Chat Server host or http_port is configured incorrectly!</span>');
					}
				}
				$check = Phpfox::getService('topcmmchat') -> validate_client('http://'.parse_url($aSettings['fc_client_loc'], PHP_URL_HOST).':'.$aSettings['fc_server_port_h'].'/');
				if($check){
					//$showmessenge = 'Client Location is configured incorrectly';
					$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Client Location is configured incorrectly!</span>');
				}
				break;
			case 1:
				$aSettings['fc_extendserver'] = 1;
    			$aSettings['fc_client_loc'] = $this->request()->get('client_loc');
				$aSettings['fc_client_loc'] = $aSettings['fc_client_loc'] ? Phpfox::getService('topcmmchat') -> addFcSlash($aSettings['fc_client_loc']) : '';
				if(empty($aSettings['fc_client_loc'])){
					//$showmessenge = 'Client Location is Empty!';
					$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Client Location is Empty!</span>');
				}
				$serverinfo = $this->getServerHostPortHost($aSettings['fc_client_loc']);
				if($serverinfo){					
					$aSettings['fc_server_host'] = empty($serverinfo['fc_server_host']) ? parse_url($aSettings['fc_client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
					$aSettings['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
					$aSettings['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
					$aSettings['fc_server_port'] = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
					$aSettings['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
		            $aSettings['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];
		            $aSettings['fc_api_url'] = 'http://' . $aSettings['fc_server_host'] . '/';
		            $aSettings['fc_group'] = substr(parse_url($aSettings['fc_client_loc'], PHP_URL_PATH),1,-1);		
		            $c_own_loc = Phpfox::getService('topcmmchat') -> validate_client($aSettings['fc_client_loc']);
					$da = Phpfox::getService('topcmmchat') -> validate_data_api($aSettings['fc_api_url'] . 'online.js?group=' . $aSettings['fc_group']);
					if($c_own_loc || $da){
			        	//$showmessenge = 'Client Location is configured incorrectly';
			        	$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Client Location is configured incorrectly!</span>');
			        }
				}else{
					//$showmessenge = 'Client Location is configured incorrectly';
					$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Client Location is configured incorrectly!</span>');
				}
				$aSettings['fc_clienttype'] = $this->request()->get('clienttype');
				break;
			default:
				$aSettings['fc_extendserver'] = 2;
				$aSettings['fc_clienttype'] = $this->request()->get('clienttype');
				$room = trim($this->request()->get('room'));
				if($room != ""){
					preg_match("/\w+$/", $room,$matches);
					if(strlen($room) != strlen($matches[0])){
						$this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Chat Room can only use numbers,letters and underline!</span>');
					}
					$aSettings['fc_room'] = $room;
				}else{
					$aSettings['fc_room'] = 'Lobby';
				}  
				break;
		}
		$aSettings['fc_room_list']		= $this->request()->get('room_list');
		$aSettings['fc_user_list']		= $this->request()->get('user_list');
		$aSettings['fc_fullscreen']		= $this->request()->get('fullscreen');
		$aSettings['fc_client_width']	= ($this->request()->get('client_width') && is_numeric($this->request()->get('client_width')) && $this->request()->get('client_width') >= 728) ? $this->request()->get('client_width') : 850; 
		$aSettings['fc_client_height']	= ($this->request()->get('client_height') && is_numeric($this->request()->get('client_height')) && $this->request()->get('client_height') >= 728) ? $this->request()->get('client_height') : 642;
		$aSettings['fc_client_lang']	= $this->request()->get('client_lang');
		$aSettings['fc_client_skin']	= $this->request()->get('client_skin');
		
		$result = Phpfox::getService('topcmmchat') -> saveFcConfig($aSettings);
		if ($result){
		     $this->url()->send('admincp.topcmmchat.settings', null, 'Settings edited successfully!</span>');
		}else{
			 $this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Settings edited failed!</span>');
		}
		
		/*$valid = Phpfox::getService('topcmmchat') -> getValid($aSettings);
		if(isset($showmessenge)){
			$this->url()->send('admincp.topcmmchat.settings', null, $showmessenge);
		}else{
			$result = Phpfox::getService('topcmmchat') -> saveFcConfig($aSettings);
			if ($result){
			     $this->url()->send('admincp.topcmmchat.settings', null, 'Settings edited successfully!</span>');
			}else{
				 $this->url()->send('admincp.topcmmchat.settings', null, '<span style="color:red;">Settings edited failed!</span>');
			}
		}*/
    }
    
    private function setFcOwnSetting(){
    	$aSettings['fc_servertype'] = $this->request()->get('servertype');
    	$client_location = $this->request()->get('client_loc');
		if($client_location){
			$aSettings['fc_client_loc'] = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
			$serverinfo = $this->getServerHostPortLocal($aSettings['fc_client_loc']);
			$aSettings['fc_server_host'] = $this->request()->get('server_host');
			if(!$aSettings['fc_server_host']){
				$aSettings['fc_server_host'] = empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host'];
			}      
            $aSettings['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $aSettings['fc_server_host'] : $serverinfo['fc_server_host_s'];
            $aSettings['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $aSettings['fc_server_host'] : $serverinfo['fc_server_host_h'];
            if(!is_numeric($this->request()->get('server_port')) || strpos($this->request()->get('server_port') ,".")!==false){
            	$aSettings['fc_server_port'] = empty($serverinfo['fc_server_port']) ? ($aSettings['fc_servertype'] ==1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
            }else{
            	$aSettings['fc_server_port'] = $this->request()->get('server_port');
            }
            if(!is_numeric($this->request()->get('server_port_h')) || strpos($this->request()->get('server_port_h') ,".")!==false){
            	$aSettings['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? ($aSettings['fc_servertype'] ==1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
            }else{
            	$aSettings['fc_server_port_h'] = $this->request()->get('server_port_h');
            }
            $aSettings['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? ($aSettings['fc_servertype'] ==1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
            $aSettings['fc_api_url'] = 'http://' . $aSettings['fc_server_host'] . ':' . $aSettings['fc_server_port_h'] . '/';
		}else{
			$aSettings['fc_server_host'] = $_SERVER['HTTP_HOST'];
            $aSettings['fc_server_host_h'] = $aSettings['fc_server_host_s'] = $aSettings['fc_server_host'];    
            if($aSettings['fc_servertype']){
            	$aSettings['fc_server_port_h'] = '31212';
	            $aSettings['fc_server_port_s'] = '51213';
	            $aSettings['fc_server_port'] = '51212';
            }else{
	            $aSettings['fc_server_port_h'] = '35555';
	            $aSettings['fc_server_port_s'] = '51128';
	            $aSettings['fc_server_port'] = '51127';
            }
            $aSettings['fc_api_url'] = 'http://' . $aSettings['fc_server_host'] . ':' . $aSettings['fc_server_port_h'] . '/';
            $aSettings['fc_client_loc'] = $aSettings['fc_api_url'];            
		}
		if($aSettings['fc_servertype'] == 1){
	        $aSettings['fc_clienttype'] = 0;
	    }else{
	        $aSettings['fc_clienttype'] = $this->request()->get('clienttype');
	    }
		return $aSettings;
    }
    
	private function getServerHostPortLocal($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
		if ($content){
			//server host
		 	preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host'] = '';
		        }
	        }
	        //server port
	        preg_match('/init_port = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port'] = '';
	        }
	        //server host s
			preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_s'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_s'] = '';
		        }
	        }
	        //server port s
	        preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_s'] = '';
	        }
	        //server host h
			preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
		        preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
		        if(isset($matches[1])){
		        	$data['fc_server_host_h'] = $matches[1];			        	
		        }else{
		        	$data['fc_server_host_h'] = '';
		        }
	        }
	        //server port h
	        preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_port_h'] = '';
	        }
	        return $data;
	    }else{
	    	return false;
	    }
	}

	private function getServerHostPortHost($client_location){
		$content = topcmmRequestRemote::requestRemote($client_location,1);
		if ($content){
			//server port
			preg_match('/init_port=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port'] = $matches[1];			        	
	        }
	        //server port s
			preg_match('/init_port_s=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_s'] = $matches[1];			        	
	        }
	        //server port h
			preg_match('/init_port_h=([0-9]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_port_h'] = $matches[1];			        	
	        }
	        //server host
			preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }
	        //server host s
			preg_match('/init_host_s=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }
	        //server host h
			preg_match('/init_host_h=([a-zA-Z0-9.]*)&/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }
	        return $data;
	    }else{
            return false;
	    }
	}
    
}

?>